/*
 * Calendar Queue for Process List
 *     - See Randy Brown, CACM 30(10): 1220-1227 (10/88).
 *     - See also SIMPACK++ code, Paul Fishwick, cis.ufl.edu.
 *
 * Ian.Mathieson@mel.dit.CSIRO.AU, 11 March 1994.
 */

/*
 * Modified slightly for new C++SIM format (release >= 1.5)
 * by M.C.Little@uk.ac.newcastle.
 * 22/3/94
 */


#if defined(NO_INLINES) && !defined(CALENDAR_CC_)

#else

#ifndef NO_INLINES
#  define INLINEF inline
#else
#  define INLINEF
#endif

INLINEF int Calendar::WhichBucket(double priority) const
{
	// calculate the bucket number for the entry
    int i = int(priority/width);        // find virtual bucket
    i = i % nBuckets;                   // find actual bucket
    return i;
}

INLINEF double Calendar::BucketTop(double priority) const
{
    long n = long(priority/width);
    return (n + 1.5) * width;
}

INLINEF std::ostream& operator<< (std::ostream& strm, const Calendar& c)
{
    return c.print(strm);
}

#ifdef INLINEF
#  undef INLINEF
#endif

#endif
