/*
 * Copyright (C) 1994
 *
 * Department of Computing Science,
 * The University,
 * Newcastle upon Tyne,
 * UK.
 */

#ifndef MEAN_H_
#define MEAN_H_

#include <iostream>
#include <fstream>

#ifndef BOOLEAN_H_
#  include "Boolean.h"
#endif

#define DLL __declspec(dllexport)

class DLL Mean
{
public:
    Mean ();
    virtual ~Mean ();

    virtual void setValue (double);
    virtual void operator+= (double);

    virtual void reset ();

    unsigned int numberOfSamples () const;

    double min () const;
    double max () const;
    double sum () const;
    double mean () const;

    virtual std::ostream& print (std::ostream&) const;    
    
protected:
    double _Max, _Min;
    double _Sum, _Mean;
    unsigned int _Number;

public:
    virtual Boolean saveState (const char*) const;
    virtual Boolean saveState (std::ofstream&) const;
    
    virtual Boolean restoreState (const char*);
    virtual Boolean restoreState (std::ifstream&);
};

#include "Mean.n"

#endif
