/*
 * Copyright (C) 1994
 *
 * Department of Computing Science,
 * The University,
 * Newcastle upon Tyne,
 * UK.
 */


#if defined(NO_INLINES) && !defined(MEAN_CC_)

extern std::ostream& operator<< (std::ostream& strm, const Mean& m);

#else

#ifndef NO_INLINES
#  define INLINEF inline
#else
#  define INLINEF
#endif


INLINEF void Mean::operator+= (double value)
{
    setValue(value);
}

INLINEF unsigned int Mean::numberOfSamples () const
{
    return _Number;
}

INLINEF double Mean::min () const
{
    return _Min;
}

INLINEF double Mean::max () const
{
    return _Max;
}

INLINEF double Mean::sum () const
{
    return _Sum;
}

INLINEF double Mean::mean () const
{
    return _Mean;
}

INLINEF std::ostream& operator<< (std::ostream& strm, const Mean& m)
{
    return m.print(strm);
}


#ifdef INLINEF
#  undef INLINEF
#endif

#endif
